import {
  HostHeaderInputConfig,
  HostHeaderResolvedConfig,
} from "@aws-sdk/middleware-host-header";
import {
  UserAgentInputConfig,
  UserAgentResolvedConfig,
} from "@aws-sdk/middleware-user-agent";
import {
  RegionInputConfig,
  RegionResolvedConfig,
} from "@smithy/config-resolver";
import {
  EndpointInputConfig,
  EndpointResolvedConfig,
} from "@smithy/middleware-endpoint";
import {
  RetryInputConfig,
  RetryResolvedConfig,
} from "@smithy/middleware-retry";
import { HttpHandlerUserInput as __HttpHandlerUserInput } from "@smithy/protocol-http";
import {
  Client as __Client,
  DefaultsMode as __DefaultsMode,
  SmithyConfiguration as __SmithyConfiguration,
  SmithyResolvedConfiguration as __SmithyResolvedConfiguration,
} from "@smithy/smithy-client";
import {
  AwsCredentialIdentityProvider,
  BodyLengthCalculator as __BodyLengthCalculator,
  CheckOptionalClientConfig as __CheckOptionalClientConfig,
  ChecksumConstructor as __ChecksumConstructor,
  Decoder as __Decoder,
  Encoder as __Encoder,
  HashConstructor as __HashConstructor,
  HttpHandlerOptions as __HttpHandlerOptions,
  Logger as __Logger,
  Provider as __Provider,
  Provider,
  StreamCollector as __StreamCollector,
  UrlParser as __UrlParser,
  UserAgent as __UserAgent,
} from "@smithy/types";
import {
  HttpAuthSchemeInputConfig,
  HttpAuthSchemeResolvedConfig,
} from "./auth/httpAuthSchemeProvider";
import {
  AttachInstancesCommandInput,
  AttachInstancesCommandOutput,
} from "./commands/AttachInstancesCommand";
import {
  AttachLoadBalancersCommandInput,
  AttachLoadBalancersCommandOutput,
} from "./commands/AttachLoadBalancersCommand";
import {
  AttachLoadBalancerTargetGroupsCommandInput,
  AttachLoadBalancerTargetGroupsCommandOutput,
} from "./commands/AttachLoadBalancerTargetGroupsCommand";
import {
  AttachTrafficSourcesCommandInput,
  AttachTrafficSourcesCommandOutput,
} from "./commands/AttachTrafficSourcesCommand";
import {
  BatchDeleteScheduledActionCommandInput,
  BatchDeleteScheduledActionCommandOutput,
} from "./commands/BatchDeleteScheduledActionCommand";
import {
  BatchPutScheduledUpdateGroupActionCommandInput,
  BatchPutScheduledUpdateGroupActionCommandOutput,
} from "./commands/BatchPutScheduledUpdateGroupActionCommand";
import {
  CancelInstanceRefreshCommandInput,
  CancelInstanceRefreshCommandOutput,
} from "./commands/CancelInstanceRefreshCommand";
import {
  CompleteLifecycleActionCommandInput,
  CompleteLifecycleActionCommandOutput,
} from "./commands/CompleteLifecycleActionCommand";
import {
  CreateAutoScalingGroupCommandInput,
  CreateAutoScalingGroupCommandOutput,
} from "./commands/CreateAutoScalingGroupCommand";
import {
  CreateLaunchConfigurationCommandInput,
  CreateLaunchConfigurationCommandOutput,
} from "./commands/CreateLaunchConfigurationCommand";
import {
  CreateOrUpdateTagsCommandInput,
  CreateOrUpdateTagsCommandOutput,
} from "./commands/CreateOrUpdateTagsCommand";
import {
  DeleteAutoScalingGroupCommandInput,
  DeleteAutoScalingGroupCommandOutput,
} from "./commands/DeleteAutoScalingGroupCommand";
import {
  DeleteLaunchConfigurationCommandInput,
  DeleteLaunchConfigurationCommandOutput,
} from "./commands/DeleteLaunchConfigurationCommand";
import {
  DeleteLifecycleHookCommandInput,
  DeleteLifecycleHookCommandOutput,
} from "./commands/DeleteLifecycleHookCommand";
import {
  DeleteNotificationConfigurationCommandInput,
  DeleteNotificationConfigurationCommandOutput,
} from "./commands/DeleteNotificationConfigurationCommand";
import {
  DeletePolicyCommandInput,
  DeletePolicyCommandOutput,
} from "./commands/DeletePolicyCommand";
import {
  DeleteScheduledActionCommandInput,
  DeleteScheduledActionCommandOutput,
} from "./commands/DeleteScheduledActionCommand";
import {
  DeleteTagsCommandInput,
  DeleteTagsCommandOutput,
} from "./commands/DeleteTagsCommand";
import {
  DeleteWarmPoolCommandInput,
  DeleteWarmPoolCommandOutput,
} from "./commands/DeleteWarmPoolCommand";
import {
  DescribeAccountLimitsCommandInput,
  DescribeAccountLimitsCommandOutput,
} from "./commands/DescribeAccountLimitsCommand";
import {
  DescribeAdjustmentTypesCommandInput,
  DescribeAdjustmentTypesCommandOutput,
} from "./commands/DescribeAdjustmentTypesCommand";
import {
  DescribeAutoScalingGroupsCommandInput,
  DescribeAutoScalingGroupsCommandOutput,
} from "./commands/DescribeAutoScalingGroupsCommand";
import {
  DescribeAutoScalingInstancesCommandInput,
  DescribeAutoScalingInstancesCommandOutput,
} from "./commands/DescribeAutoScalingInstancesCommand";
import {
  DescribeAutoScalingNotificationTypesCommandInput,
  DescribeAutoScalingNotificationTypesCommandOutput,
} from "./commands/DescribeAutoScalingNotificationTypesCommand";
import {
  DescribeInstanceRefreshesCommandInput,
  DescribeInstanceRefreshesCommandOutput,
} from "./commands/DescribeInstanceRefreshesCommand";
import {
  DescribeLaunchConfigurationsCommandInput,
  DescribeLaunchConfigurationsCommandOutput,
} from "./commands/DescribeLaunchConfigurationsCommand";
import {
  DescribeLifecycleHooksCommandInput,
  DescribeLifecycleHooksCommandOutput,
} from "./commands/DescribeLifecycleHooksCommand";
import {
  DescribeLifecycleHookTypesCommandInput,
  DescribeLifecycleHookTypesCommandOutput,
} from "./commands/DescribeLifecycleHookTypesCommand";
import {
  DescribeLoadBalancersCommandInput,
  DescribeLoadBalancersCommandOutput,
} from "./commands/DescribeLoadBalancersCommand";
import {
  DescribeLoadBalancerTargetGroupsCommandInput,
  DescribeLoadBalancerTargetGroupsCommandOutput,
} from "./commands/DescribeLoadBalancerTargetGroupsCommand";
import {
  DescribeMetricCollectionTypesCommandInput,
  DescribeMetricCollectionTypesCommandOutput,
} from "./commands/DescribeMetricCollectionTypesCommand";
import {
  DescribeNotificationConfigurationsCommandInput,
  DescribeNotificationConfigurationsCommandOutput,
} from "./commands/DescribeNotificationConfigurationsCommand";
import {
  DescribePoliciesCommandInput,
  DescribePoliciesCommandOutput,
} from "./commands/DescribePoliciesCommand";
import {
  DescribeScalingActivitiesCommandInput,
  DescribeScalingActivitiesCommandOutput,
} from "./commands/DescribeScalingActivitiesCommand";
import {
  DescribeScalingProcessTypesCommandInput,
  DescribeScalingProcessTypesCommandOutput,
} from "./commands/DescribeScalingProcessTypesCommand";
import {
  DescribeScheduledActionsCommandInput,
  DescribeScheduledActionsCommandOutput,
} from "./commands/DescribeScheduledActionsCommand";
import {
  DescribeTagsCommandInput,
  DescribeTagsCommandOutput,
} from "./commands/DescribeTagsCommand";
import {
  DescribeTerminationPolicyTypesCommandInput,
  DescribeTerminationPolicyTypesCommandOutput,
} from "./commands/DescribeTerminationPolicyTypesCommand";
import {
  DescribeTrafficSourcesCommandInput,
  DescribeTrafficSourcesCommandOutput,
} from "./commands/DescribeTrafficSourcesCommand";
import {
  DescribeWarmPoolCommandInput,
  DescribeWarmPoolCommandOutput,
} from "./commands/DescribeWarmPoolCommand";
import {
  DetachInstancesCommandInput,
  DetachInstancesCommandOutput,
} from "./commands/DetachInstancesCommand";
import {
  DetachLoadBalancersCommandInput,
  DetachLoadBalancersCommandOutput,
} from "./commands/DetachLoadBalancersCommand";
import {
  DetachLoadBalancerTargetGroupsCommandInput,
  DetachLoadBalancerTargetGroupsCommandOutput,
} from "./commands/DetachLoadBalancerTargetGroupsCommand";
import {
  DetachTrafficSourcesCommandInput,
  DetachTrafficSourcesCommandOutput,
} from "./commands/DetachTrafficSourcesCommand";
import {
  DisableMetricsCollectionCommandInput,
  DisableMetricsCollectionCommandOutput,
} from "./commands/DisableMetricsCollectionCommand";
import {
  EnableMetricsCollectionCommandInput,
  EnableMetricsCollectionCommandOutput,
} from "./commands/EnableMetricsCollectionCommand";
import {
  EnterStandbyCommandInput,
  EnterStandbyCommandOutput,
} from "./commands/EnterStandbyCommand";
import {
  ExecutePolicyCommandInput,
  ExecutePolicyCommandOutput,
} from "./commands/ExecutePolicyCommand";
import {
  ExitStandbyCommandInput,
  ExitStandbyCommandOutput,
} from "./commands/ExitStandbyCommand";
import {
  GetPredictiveScalingForecastCommandInput,
  GetPredictiveScalingForecastCommandOutput,
} from "./commands/GetPredictiveScalingForecastCommand";
import {
  PutLifecycleHookCommandInput,
  PutLifecycleHookCommandOutput,
} from "./commands/PutLifecycleHookCommand";
import {
  PutNotificationConfigurationCommandInput,
  PutNotificationConfigurationCommandOutput,
} from "./commands/PutNotificationConfigurationCommand";
import {
  PutScalingPolicyCommandInput,
  PutScalingPolicyCommandOutput,
} from "./commands/PutScalingPolicyCommand";
import {
  PutScheduledUpdateGroupActionCommandInput,
  PutScheduledUpdateGroupActionCommandOutput,
} from "./commands/PutScheduledUpdateGroupActionCommand";
import {
  PutWarmPoolCommandInput,
  PutWarmPoolCommandOutput,
} from "./commands/PutWarmPoolCommand";
import {
  RecordLifecycleActionHeartbeatCommandInput,
  RecordLifecycleActionHeartbeatCommandOutput,
} from "./commands/RecordLifecycleActionHeartbeatCommand";
import {
  ResumeProcessesCommandInput,
  ResumeProcessesCommandOutput,
} from "./commands/ResumeProcessesCommand";
import {
  RollbackInstanceRefreshCommandInput,
  RollbackInstanceRefreshCommandOutput,
} from "./commands/RollbackInstanceRefreshCommand";
import {
  SetDesiredCapacityCommandInput,
  SetDesiredCapacityCommandOutput,
} from "./commands/SetDesiredCapacityCommand";
import {
  SetInstanceHealthCommandInput,
  SetInstanceHealthCommandOutput,
} from "./commands/SetInstanceHealthCommand";
import {
  SetInstanceProtectionCommandInput,
  SetInstanceProtectionCommandOutput,
} from "./commands/SetInstanceProtectionCommand";
import {
  StartInstanceRefreshCommandInput,
  StartInstanceRefreshCommandOutput,
} from "./commands/StartInstanceRefreshCommand";
import {
  SuspendProcessesCommandInput,
  SuspendProcessesCommandOutput,
} from "./commands/SuspendProcessesCommand";
import {
  TerminateInstanceInAutoScalingGroupCommandInput,
  TerminateInstanceInAutoScalingGroupCommandOutput,
} from "./commands/TerminateInstanceInAutoScalingGroupCommand";
import {
  UpdateAutoScalingGroupCommandInput,
  UpdateAutoScalingGroupCommandOutput,
} from "./commands/UpdateAutoScalingGroupCommand";
import {
  ClientInputEndpointParameters,
  ClientResolvedEndpointParameters,
  EndpointParameters,
} from "./endpoint/EndpointParameters";
import { RuntimeExtension, RuntimeExtensionsConfig } from "./runtimeExtensions";
export { __Client };
export type ServiceInputTypes =
  | AttachInstancesCommandInput
  | AttachLoadBalancerTargetGroupsCommandInput
  | AttachLoadBalancersCommandInput
  | AttachTrafficSourcesCommandInput
  | BatchDeleteScheduledActionCommandInput
  | BatchPutScheduledUpdateGroupActionCommandInput
  | CancelInstanceRefreshCommandInput
  | CompleteLifecycleActionCommandInput
  | CreateAutoScalingGroupCommandInput
  | CreateLaunchConfigurationCommandInput
  | CreateOrUpdateTagsCommandInput
  | DeleteAutoScalingGroupCommandInput
  | DeleteLaunchConfigurationCommandInput
  | DeleteLifecycleHookCommandInput
  | DeleteNotificationConfigurationCommandInput
  | DeletePolicyCommandInput
  | DeleteScheduledActionCommandInput
  | DeleteTagsCommandInput
  | DeleteWarmPoolCommandInput
  | DescribeAccountLimitsCommandInput
  | DescribeAdjustmentTypesCommandInput
  | DescribeAutoScalingGroupsCommandInput
  | DescribeAutoScalingInstancesCommandInput
  | DescribeAutoScalingNotificationTypesCommandInput
  | DescribeInstanceRefreshesCommandInput
  | DescribeLaunchConfigurationsCommandInput
  | DescribeLifecycleHookTypesCommandInput
  | DescribeLifecycleHooksCommandInput
  | DescribeLoadBalancerTargetGroupsCommandInput
  | DescribeLoadBalancersCommandInput
  | DescribeMetricCollectionTypesCommandInput
  | DescribeNotificationConfigurationsCommandInput
  | DescribePoliciesCommandInput
  | DescribeScalingActivitiesCommandInput
  | DescribeScalingProcessTypesCommandInput
  | DescribeScheduledActionsCommandInput
  | DescribeTagsCommandInput
  | DescribeTerminationPolicyTypesCommandInput
  | DescribeTrafficSourcesCommandInput
  | DescribeWarmPoolCommandInput
  | DetachInstancesCommandInput
  | DetachLoadBalancerTargetGroupsCommandInput
  | DetachLoadBalancersCommandInput
  | DetachTrafficSourcesCommandInput
  | DisableMetricsCollectionCommandInput
  | EnableMetricsCollectionCommandInput
  | EnterStandbyCommandInput
  | ExecutePolicyCommandInput
  | ExitStandbyCommandInput
  | GetPredictiveScalingForecastCommandInput
  | PutLifecycleHookCommandInput
  | PutNotificationConfigurationCommandInput
  | PutScalingPolicyCommandInput
  | PutScheduledUpdateGroupActionCommandInput
  | PutWarmPoolCommandInput
  | RecordLifecycleActionHeartbeatCommandInput
  | ResumeProcessesCommandInput
  | RollbackInstanceRefreshCommandInput
  | SetDesiredCapacityCommandInput
  | SetInstanceHealthCommandInput
  | SetInstanceProtectionCommandInput
  | StartInstanceRefreshCommandInput
  | SuspendProcessesCommandInput
  | TerminateInstanceInAutoScalingGroupCommandInput
  | UpdateAutoScalingGroupCommandInput;
export type ServiceOutputTypes =
  | AttachInstancesCommandOutput
  | AttachLoadBalancerTargetGroupsCommandOutput
  | AttachLoadBalancersCommandOutput
  | AttachTrafficSourcesCommandOutput
  | BatchDeleteScheduledActionCommandOutput
  | BatchPutScheduledUpdateGroupActionCommandOutput
  | CancelInstanceRefreshCommandOutput
  | CompleteLifecycleActionCommandOutput
  | CreateAutoScalingGroupCommandOutput
  | CreateLaunchConfigurationCommandOutput
  | CreateOrUpdateTagsCommandOutput
  | DeleteAutoScalingGroupCommandOutput
  | DeleteLaunchConfigurationCommandOutput
  | DeleteLifecycleHookCommandOutput
  | DeleteNotificationConfigurationCommandOutput
  | DeletePolicyCommandOutput
  | DeleteScheduledActionCommandOutput
  | DeleteTagsCommandOutput
  | DeleteWarmPoolCommandOutput
  | DescribeAccountLimitsCommandOutput
  | DescribeAdjustmentTypesCommandOutput
  | DescribeAutoScalingGroupsCommandOutput
  | DescribeAutoScalingInstancesCommandOutput
  | DescribeAutoScalingNotificationTypesCommandOutput
  | DescribeInstanceRefreshesCommandOutput
  | DescribeLaunchConfigurationsCommandOutput
  | DescribeLifecycleHookTypesCommandOutput
  | DescribeLifecycleHooksCommandOutput
  | DescribeLoadBalancerTargetGroupsCommandOutput
  | DescribeLoadBalancersCommandOutput
  | DescribeMetricCollectionTypesCommandOutput
  | DescribeNotificationConfigurationsCommandOutput
  | DescribePoliciesCommandOutput
  | DescribeScalingActivitiesCommandOutput
  | DescribeScalingProcessTypesCommandOutput
  | DescribeScheduledActionsCommandOutput
  | DescribeTagsCommandOutput
  | DescribeTerminationPolicyTypesCommandOutput
  | DescribeTrafficSourcesCommandOutput
  | DescribeWarmPoolCommandOutput
  | DetachInstancesCommandOutput
  | DetachLoadBalancerTargetGroupsCommandOutput
  | DetachLoadBalancersCommandOutput
  | DetachTrafficSourcesCommandOutput
  | DisableMetricsCollectionCommandOutput
  | EnableMetricsCollectionCommandOutput
  | EnterStandbyCommandOutput
  | ExecutePolicyCommandOutput
  | ExitStandbyCommandOutput
  | GetPredictiveScalingForecastCommandOutput
  | PutLifecycleHookCommandOutput
  | PutNotificationConfigurationCommandOutput
  | PutScalingPolicyCommandOutput
  | PutScheduledUpdateGroupActionCommandOutput
  | PutWarmPoolCommandOutput
  | RecordLifecycleActionHeartbeatCommandOutput
  | ResumeProcessesCommandOutput
  | RollbackInstanceRefreshCommandOutput
  | SetDesiredCapacityCommandOutput
  | SetInstanceHealthCommandOutput
  | SetInstanceProtectionCommandOutput
  | StartInstanceRefreshCommandOutput
  | SuspendProcessesCommandOutput
  | TerminateInstanceInAutoScalingGroupCommandOutput
  | UpdateAutoScalingGroupCommandOutput;
export interface ClientDefaults
  extends Partial<__SmithyConfiguration<__HttpHandlerOptions>> {
  requestHandler?: __HttpHandlerUserInput;
  sha256?: __ChecksumConstructor | __HashConstructor;
  urlParser?: __UrlParser;
  bodyLengthChecker?: __BodyLengthCalculator;
  streamCollector?: __StreamCollector;
  base64Decoder?: __Decoder;
  base64Encoder?: __Encoder;
  utf8Decoder?: __Decoder;
  utf8Encoder?: __Encoder;
  runtime?: string;
  disableHostPrefix?: boolean;
  serviceId?: string;
  useDualstackEndpoint?: boolean | __Provider<boolean>;
  useFipsEndpoint?: boolean | __Provider<boolean>;
  region?: string | __Provider<string>;
  defaultUserAgentProvider?: Provider<__UserAgent>;
  credentialDefaultProvider?: (input: any) => AwsCredentialIdentityProvider;
  maxAttempts?: number | __Provider<number>;
  retryMode?: string | __Provider<string>;
  logger?: __Logger;
  extensions?: RuntimeExtension[];
  defaultsMode?: __DefaultsMode | __Provider<__DefaultsMode>;
}
export type AutoScalingClientConfigType = Partial<
  __SmithyConfiguration<__HttpHandlerOptions>
> &
  ClientDefaults &
  UserAgentInputConfig &
  RetryInputConfig &
  RegionInputConfig &
  HostHeaderInputConfig &
  EndpointInputConfig<EndpointParameters> &
  HttpAuthSchemeInputConfig &
  ClientInputEndpointParameters;
export interface AutoScalingClientConfig extends AutoScalingClientConfigType {}
export type AutoScalingClientResolvedConfigType =
  __SmithyResolvedConfiguration<__HttpHandlerOptions> &
    Required<ClientDefaults> &
    RuntimeExtensionsConfig &
    UserAgentResolvedConfig &
    RetryResolvedConfig &
    RegionResolvedConfig &
    HostHeaderResolvedConfig &
    EndpointResolvedConfig<EndpointParameters> &
    HttpAuthSchemeResolvedConfig &
    ClientResolvedEndpointParameters;
export interface AutoScalingClientResolvedConfig
  extends AutoScalingClientResolvedConfigType {}
export declare class AutoScalingClient extends __Client<
  __HttpHandlerOptions,
  ServiceInputTypes,
  ServiceOutputTypes,
  AutoScalingClientResolvedConfig
> {
  readonly config: AutoScalingClientResolvedConfig;
  constructor(
    ...[configuration]: __CheckOptionalClientConfig<AutoScalingClientConfig>
  );
  destroy(): void;
}
